classification
Title: update to autoconf2.65
Type: Stage: resolved
Components: Build Versions: Python 3.2, Python 2.7
process
Status: closed Resolution: accepted
Dependencies: Superseder:
Assigned To: Nosy List: Arfrever, doko, loewis, mark.dickinson, rpetrov, vstinner
Priority: normal Keywords: needs review, patch

Created on 2010-04-23 15:26 by doko, last changed 2010-05-11 10:34 by mark.dickinson. This issue is now closed.

Files
File name Uploaded Description Edit
autoconf2.65.diff doko, 2010-04-23 15:26
configure.in.diff doko, 2010-04-24 17:35
Messages (20)
msg104018 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-04-23 15:26
update to autoconf2.65
msg104021 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-04-23 15:33
see http://mail.python.org/pipermail/python-dev/2010-April/099639.html
msg104047 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2010-04-23 20:25
I don't think Python 2.7 should upgrade to a newer autoconf version at this point. For 3.2, we could try it out.
msg104109 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-04-24 17:35
here is the diff for configure.in. The __EXTENSIONS__ macro is defined by 2.65 for Solaris, removed this explicit definition. running a test build
msg104152 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-04-25 18:35
r80474: Replace AC_HELP_STRING with AS_HELP_STRING
msg104157 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-04-25 18:44
r80475: s/AC_AIX/AC_USE_SYSTEM_EXTENSIONS/
msg104163 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-04-25 21:01
r80478 converts all obsolete AC_TRY_* macros to AC_*_IFELSE, the outcome is ... nothing (but whitespace changes):

$ svn diff --diff-cmd diff -x -uEwB configure
Index: configure
===================================================================
--- configure	(Revision 80475)
+++ configure	(Arbeitskopie)
@@ -1,5 +1,5 @@
 #! /bin/sh
-# From configure.in Revision: 80474 .
+# From configure.in Revision: 80475 .
 # Guess values for system-dependent variables and create Makefiles.
 # Generated by GNU Autoconf 2.65 for python 3.2.
 #

running configure with the old and the new version shows no diffs (besides config.log).
msg104167 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-04-25 21:20
r80481: configure.in: Avoid autoconf warning: Assume C89 semantics that
RETSIGTYPE is always void (issue #8510).

Keep the definition, although the python code itself doesn't use it anymore.
msg104168 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-04-25 21:24
r80483: Makefile.pre.in (autoconf): Call autoconf/autoheader with -Wall to help the configure script to stay warning free.
msg104467 - (view) Author: Roumen Petrov (rpetrov) * Date: 2010-04-28 21:47
You don't need to add source in case of 
   AC_COMPILE_IFELSE([AC_LANG_SOURCE([[]])] .. 
when the the test is ..main() { return 0 ;} ...
, posted long time ago as part of issue3754 ( 	minimal cross-compilation support for configure ).
Also thanks for fixing extra comma in after replacement of AC_TRY_COMPILE .

This part is save to be added to 2.7 build.
msg104501 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-04-29 13:21
> You don't need to add source in case of 
>   AC_COMPILE_IFELSE([AC_LANG_SOURCE([[]])] .. 
> when the the test is ..main() { return 0 ;} ...

is there a version of the cross configure patch for 3.x?
msg105271 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-05-08 10:03
the update to 2.65 on the py3k branch only did show whitespace changes, applying these changes to the trunk.

r80964: require autoconf-2.65
msg105277 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2010-05-08 11:09
r80965: Replace AC_HELP_STRING with AS_HELP_STRING
r80966: s/AC_AIX/AC_USE_SYSTEM_EXTENSIONS/
r80969: convert all obsolete AC_TRY_* macros to AC_*_IFELSE
r80970: Avoid autoconf warning: Assume C89 semantics that RETSIGTYPE is always void
msg105375 - (view) Author: Mark Dickinson (mark.dickinson) * (Python committer) Date: 2010-05-09 09:07
r81004: Remove extra closing bracket and comma introduced in r80969.  (This was causing misdetection of the OS X 10.5 SDK on Linux and OS X, and a test_platform failure on OS X.)
msg105427 - (view) Author: Roumen Petrov (rpetrov) * Date: 2010-05-10 10:21
I don't have access to source so my comment will be based only on diffs from above mentioned revisions.
r80969:
- AC_LANG_PROGRAM ... with main function in body . It is legal as I don't know C compiler that fail to compile code like ...int main() { int main() {...} ...} but is better to left body empty. Counted three times. All those cases tests for compiler flags and I think that AC_LANG_SOURCE is enough.

- body include  #include "confdefs.h" - may be buggy (before) and now AC_LANG_PROGRAM will add all defines. Counted any times. I think that is save to remove  #include "confdefs.h" from all those test cases.
msg105488 - (view) Author: Mark Dickinson (mark.dickinson) * (Python committer) Date: 2010-05-11 08:55
Roumen:  good catch!  Indeed, nested functions aren't legal in standard C, and the test for -fno-strict-aliasing now fails on my OS X 10.6.3 machine, where it used to pass:

  checking whether gcc accepts -fno-strict-aliasing... no

config.log contains:

  configure:5400: checking whether gcc accepts -fno-strict-aliasing
  configure:5418: gcc -fno-strict-aliasing -c -g -O2  conftest.c >&5
  conftest.c: In function 'main':
  conftest.c:27: error: nested functions are disabled, use -fnested-functions to re-enable
  configure:5418: $? = 1
  configure: failed program was:
  ...

Fixed these cases above and removed the extra '#include "confdefs.h"' lines (which seem harmless, but unnecessary) in r81077 (trunk).
msg105491 - (view) Author: Mark Dickinson (mark.dickinson) * (Python committer) Date: 2010-05-11 09:24
Merged to py3k, and fixed up an additional nested 'int main()', in r81078.
msg105493 - (view) Author: Mark Dickinson (mark.dickinson) * (Python committer) Date: 2010-05-11 09:53
BTW, it looks as though the nested functions were introduced in r76030;  nothing to do with Matthias's autoconf 2.65 update.
msg105495 - (view) Author: Mark Dickinson (mark.dickinson) * (Python committer) Date: 2010-05-11 10:23
Just double checked that r80969 didn't introduce any other non-whitespace changes: apart from the now-fixed OS X 10.5 SDK issue), the only other non-whitespace change was:

@@ -7018,7 +7023,7 @@
 int
 main ()
 {
-long double x; x = (long double)0.;
+long double x; x = (long double)0;
   ;
   return 0;
 }

which looks harmless to me.
msg105496 - (view) Author: Mark Dickinson (mark.dickinson) * (Python committer) Date: 2010-05-11 10:34
Closing.  Roumen, please open a new issue for any other configure issues that aren't related to this autoconf update.
History
Date User Action Args
2010-05-11 10:34:12mark.dickinsonsetstatus: open -> closed
resolution: accepted
messages: + msg105496

stage: resolved
2010-05-11 10:23:18mark.dickinsonsetmessages: + msg105495
2010-05-11 09:53:34mark.dickinsonsetmessages: + msg105493
2010-05-11 09:24:32mark.dickinsonsetmessages: + msg105491
2010-05-11 08:55:18mark.dickinsonsetmessages: + msg105488
2010-05-10 10:21:18rpetrovsetmessages: + msg105427
2010-05-09 09:07:37mark.dickinsonsetnosy: + mark.dickinson
messages: + msg105375
2010-05-08 11:09:06dokosetmessages: + msg105277
2010-05-08 10:03:23dokosetmessages: + msg105271
2010-04-29 13:21:27dokosetmessages: + msg104501
2010-04-28 21:47:08rpetrovsetnosy: + rpetrov
messages: + msg104467
2010-04-25 21:24:29dokosetmessages: + msg104168
2010-04-25 21:20:17dokosetmessages: + msg104167
2010-04-25 21:01:11dokosetmessages: + msg104163
2010-04-25 18:44:02dokosetmessages: + msg104157
2010-04-25 18:35:00dokosetmessages: + msg104152
2010-04-24 17:35:01dokosetfiles: + configure.in.diff

messages: + msg104109
2010-04-23 20:25:22loewissetnosy: + loewis
messages: + msg104047
2010-04-23 16:00:42Arfreversetnosy: + Arfrever
2010-04-23 15:57:18vstinnersetnosy: + vstinner
2010-04-23 15:33:29dokosetmessages: + msg104021
2010-04-23 15:26:17dokocreate